<#macro panelLogic item>
<@compress single_line=true>
<#if item.getLogicType() == 'GROUP'>
<#if item.isNotMode()>
!(
</#if>
<#if item.getPSPanelItemLogics()??>
<#list item.getPSPanelItemLogics() as subLogic>
<#if subLogic_index gt 0>
<#if item.getGroupOP() == 'AND'> 
&&
</#if>
<#if item.getGroupOP() == 'OR'>
||
</#if>
</#if>
<@panelLogic subLogic/>
</#list>
</#if>
<#if item.isNotMode()>
)
</#if>
<#elseif item.getLogicType() == 'SINGLE'>
this.$verify.testCond(_${item.getDstModelField()?lower_case}, "${item.getCondOp()}", "${item.getValue()}")
</#if>
</@compress>
</#macro>

<#macro panelItemLogic panelItem>
<#if panelItem.getPSPanelItemGroupLogic('ITEMBLANK')??>
<#assign ITEMBLANK = panelItem.getPSPanelItemGroupLogic('ITEMBLANK')/>
if (Object.is(name, '')<#if ITEMBLANK.getRelatedItemNames()??><#list ITEMBLANK.getRelatedItemNames() as detailName> || Object.is(name, '${detailName}')</#list></#if>) {
    let ret = true;
    <#if ITEMBLANK.getRelatedItemNames()??>
    <#list ITEMBLANK.getRelatedItemNames() as detailName>
    const _${detailName} = this.layoutData['${detailName}'];
    </#list>
    </#if>
    if (<@panelLogic ITEMBLANK/>) {
        ret = false;
    }
    this.layoutModelDetails['${panelItem.name}'].required = ret;
}
</#if>
<#if panelItem.getPSPanelItemGroupLogic('ITEMENABLE')??>
<#assign ITEMENABLE = panelItem.getPSPanelItemGroupLogic('ITEMENABLE')/>
if (Object.is(name, '')<#if ITEMENABLE.getRelatedItemNames()??><#list ITEMENABLE.getRelatedItemNames() as detailName> || Object.is(name, '${detailName}')</#list></#if>) {
    let ret = false;
    <#if ITEMENABLE.getRelatedItemNames()??>
    <#list ITEMENABLE.getRelatedItemNames() as detailName>
    const _${detailName} = this.layoutData['${detailName}'];
    </#list>
    </#if>
    if (<@panelLogic ITEMENABLE/>) {
        ret = true;
    }
    this.layoutModelDetails['${panelItem.name}'].disabled = !ret;
}
</#if>
<#if panelItem.getPSPanelItemGroupLogic('PANELVISIBLE')??>
<#assign PANELVISIBLE = panelItem.getPSPanelItemGroupLogic('PANELVISIBLE')/>
if (Object.is(name, '')<#if PANELVISIBLE.getRelatedItemNames()??><#list PANELVISIBLE.getRelatedItemNames() as detailName> || Object.is(name, '${detailName}')</#list></#if>) {
    let ret = false;
    <#if PANELVISIBLE.getRelatedItemNames()??>
    <#list PANELVISIBLE.getRelatedItemNames() as detailName>
    const _${detailName} = this.layoutData['${detailName}'];
    </#list>
    </#if>
    if (<@panelLogic PANELVISIBLE/>) {
        ret = true;
    }
    this.layoutModelDetails['${panelItem.name}'].visible = ret;
}
</#if>
</#macro>